import camera
import network
import time
import gc
import jasnosc

import p
from machine import Pin, PWM

latarka = PWM(Pin(4), 100)
latarka.duty(0)

SETPOINT = 50

Kp = 3

try:
    camera.init(0, format=camera.GRAYSCALE, framesize=camera.FRAME_QQVGA, xclk_freq=camera.XCLK_10MHz, fb_location=camera.PSRAM)
    #print('Taking a Photo')
    #camera.speffect(camera.EFFECT_NONE)
    #camera.whitebalance(camera.WB_NONE)
    #camera.saturation(0)   # Neutralny balans bieli
    # -2
    #camera.brightness(0)   # Neutralna jasność
    #camera.contrast(0)     # Neutralny kontrast
    # 2
    
    
    while True:
        #start_time = time.ticks_ms()
        buffer = camera.capture()
        
        average_brightness = jasnosc.calculate_average_brightness(buffer)
        print(average_brightness)
        
        buffer = None  # Usuń dane bufora
        gc.collect()   # Wymuś zbieranie pamięci
        
        control_signal = p.p_controller(SETPOINT, average_brightness, Kp)

        #print("control_signal:", control_signal)
        control_signal = round(control_signal)
        if control_signal < 0:
                control_signal = 0
        #print("control_signal:", control_signal)
        
        latarka.duty(control_signal)
        time.sleep(0.2)
        
        #end_time = time.ticks_ms()
        #elapsed_time = time.ticks_diff(end_time, start_time)
        #print("Iteration time (ms):", elapsed_time)
            
except Exception as e:
    print('An issue occurred')
    
finally:
    camera.deinit()
    print('Camera deinitialized')

